/********************************************************************
    file:       bangCommands.cpp
	
    purpose:    !bang command functions
*********************************************************************/


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Includes
//
#include "alresource.h"
#include "bangCommands.h"
#include "utility.h"
#include "../ls-b247/utility/safeptr.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// globals
//
extern HINSTANCE g_hInstance;

bangcmddef g_Bangs[] =
{
    "!al_generatehtml", BangGenerateHTML,
    "!al_godown", BangGoDown,
    "!al_goup", BangGoUp,
    "!al_jumpto", BangJumpTo,
    "!al_next", BangNext,
    "!al_prev", BangPrev,
    "!al_playalbum", BangPlayAlbum,
    "!al_playall", BangPlayAll,
    "!al_playindex", BangPlayIndex,
    "!al_playrand", BangPlayRand,
    "!al_properties", BangProperties,
    "!al_quickrefresh", BangQuickRefresh,
    "!al_refresh", BangRefresh,
    "!al_windowshade", BangWindowShade,
    NULL, NULL
};


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// initialization/cleanup
//

// add bang commands
void AddBangCommands()
{
    bangcmddef *pBang = g_Bangs;
    
    while (pBang->pszName != NULL)
    {
        AddBangCommand(pBang->pszName, pBang->pbCommand);
        pBang++;
    }
}

// remove bang commands
void RemoveBangCommands()
{
    bangcmddef *pBang = g_Bangs;
    
    while (pBang->pszName != NULL)
    {
        RemoveBangCommand(pBang->pszName);
        pBang++;
    }
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// !bang command functions
//
void BangGenerateHTML(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALCmdMessage(IDC_EXPORTLIST);
}

void BangGoDown(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALCmdMessage(IDC_NEXTALBUM);
}

void BangGoUp(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALCmdMessage(IDC_PREVALBUM);
}

void BangJumpTo(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    SetForegroundWindow(GetAlbumListWnd());
    PostALCmdMessage(IDC_JUMPTOALBUM);
    CenterDialog();
}

void BangNext(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALMessage(IPC_PLAYNEXTALBUM, 0);
}

void BangPrev(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALMessage(IPC_PLAYPREVALBUM, 0);
}

void BangPlayAlbum(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALCmdMessage(IDC_SELECTALBUM);
}

void BangPlayAll(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALMessage(IPC_PLAYALLALBUMS, 0);
}

void BangPlayIndex(IN HWND /* hCaller */, IN LPCSTR pszArguments)
{
    if (IsValidStringPtr(pszArguments))
    {
        int nAlbum = strtol(pszArguments, NULL, 0);
        PostALMessage(IPC_PLAYALBUM1, (LPARAM)nAlbum);
    }
}

void BangPlayRand(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALMessage(IPC_PLAYRANDOMALBUM, 0);
}

void BangProperties(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    SetForegroundWindow(GetAlbumListWnd());
    PostALCmdMessage(IDC_SHOW_PROPERTIES);
    CenterDialog();
}

void BangQuickRefresh(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALCmdMessage(IDC_REFRESH_QUICK);
}

void BangRefresh(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALCmdMessage(IDC_REFRESH);
}

void BangWindowShade(IN HWND /* hCaller */, IN LPCSTR /* pszArguments */)
{
    PostALCmdMessage(IDC_WINSHADEMODE);
}